//Register Events
RegisterOutputEvent("Player","SetWanted", "list Trespassing 0 Possession 1 Assault 2 Murder 3");
RegisterOutputEvent("Player","RemoveWanted"); 
RegisterOutputEvent("Player","RemoveMinorWanted");
registerOutputEvent(fxDTSBrick, "ifWanted", "",1);
registerInputEvent(fxDTSBrick, "VariableTrue", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "VariableFalse", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
//Test
$LegalItem = 0; 
//Prefs
if(isFunction(RTB_registerPref))
{
    // execute the pref handler file if it was disabled for some reason (?)
    if(!$RTB::Hooks::ServerControl)
        exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");

    // register the prefs for the RTB menu
    RTB_registerPref("Team that can't become wanted","Wanted","$Pref::Server::Team1","string 64","Server_Wanted",0,0,1);
    RTB_registerPref("Team that can become wanted","Wanted","$Pref::Server::Team2","string 64","Server_Wanted",0,0,1);
    RTB_registerPref("Legal items, seperate with commas","Wanted","$Pref::Server::LegalItems","string 100","Server_Wanted",0,0,1);
    RTB_registerPref("Legal items count","Wanted","$Pref::Server::LegalItemCount","int 0 8","Server_Wanted",0,0,1);
    RTB_registerPref("Reset wanted level on respawn?","Wanted","$Pref::Server::ResetOnDeath","list No 0 MinorCrimes 1 Yes 2","Server_Wanted",0,0,2);
	RTB_registerPref("Use teams?","Wanted","$Pref::Server::WantedUseTeams","list No 0 Yes 1","Server_Wanted",0,0,1);
	RTB_registerPref("Should items be illegal by default?","Wanted","$Pref::Server::ItemsIllegal","list No 0 Yes 1","Server_Wanted",0,0,1);
	RTB_registerPref("Drop items on death?","Wanted","$Pref::Server::DropItems","list No 0 Yes 1","Server_Wanted",0,0,1);
	RTB_registerPref("Prevent item planting?","Wanted","$Pref::Server::PreventItemPlant","list No 0 Yes 1","Server_Wanted",0,0,1);
	RTB_registerPref("Automatically moderate freekills?","Wanted","$Pref::Server::FreekillPunish","list No 0 Yes 1","Server_Wanted",0,0,1);
	RTB_registerPref("Allow time to pardon freekills?","Wanted","$Pref::Server::FreekillExplain","list No 0 Yes 1","Server_Wanted",0,0,1);
}
else
{
    // RTB doesn't exist, assign default values
    // if you don't have RTB, change these in console and they will save automatically upon exit
    $Pref::Server::Team1 = "Guards";
    $Pref::Server::Team2 = "Prisoners";
    $Pref::Server::ResetOnDeath = 2;
    $Pref::Server::LegalItems = "Push Broom,Fist"; //Separated by a comma no space
    $Pref::Server::LegalItemCount = 2;
	$Pref::Server::WantedUseTeams = 1;
	$Pref::Server::ItemsIllegal = 1;
	$Pref::Server::DropItems = 1;
	$Pref::Server::PreventItemPlant = 1;
	$Pref::Server::FreekillPunish = 0;
	$Pref::Server::FreekillExplain = 0;
}
//Set wanted
function Player::SetWanted(%this,%val)
{
    if(isObject(%this.client))
    {
		if(%this.client.slyrTeam.name $= $Pref::Server::Team2 || $Pref::Server::WantedUseTeams == 0)
		{
        %this.client.isWanted = 1;
        bottomprint(%this.client, $wantedBottomPrint, -1, 1);
		if(%val == 0)
		{
			%this.client.trespassingCounts++;
		}
		if(%val == 1)
		{
			%this.client.possessionCounts++;
		}
		if(%val == 2)
		{
			%this.client.assaultCounts++;
		}
		if(%val == 3)
		{
			%this.client.murderCounts++;
		}
		}
    } 
}
//Remove wanted status and reset assault counts
function Player::RemoveWanted(%this,%val)
{
    if(isObject(%this.client))
    {
        if(%this.client.isWanted == 1)
        {
            %this.client.isWanted = 0;
            %this.client.assaultCounts = 0;
            %this.client.murderCounts = 0;
			%this.client.possessionCounts = 0;
			%this.client.trespassingCounts = 0;
            bottomprint(%this.client, "", 0, 0);
        }
    } 
}
function Player::RemoveMinorWanted(%this,%val)
{
    if(isObject(%this.client))
    {
        if(%this.client.isWanted == 1)
        {
        if(%this.client.assaultcounts == 0 && %this.client.murderCounts == 0)
        {
            %this.client.isWanted = 0;
            %this.client.assaultCounts = 0;
            %this.client.murderCounts = 0;
			%this.client.possessionCounts = 0;
			%this.client.trespassingCounts = 0;
            bottomprint(%this.client, "", 0, 0);
        }
        }
    } 
}
function fxDTSBrick::VariableTrue(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("VariableTrue", %client);
}

function fxDTSBrick::VariableFalse(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("VariableFalse", %client);
}

function fxDTSBrick::ifWanted(%this,%client)
{
if(%client.isWanted == 1) 
{
     %this.variableTrue(%client); 
	 return;
}
if(%client.isWanted != 1)
{
	%this.variableFalse(%client);
	return;
}
}
//Wanted Death
function wantedDeath(%client)
{
	if(%client.murderCounts >= 1)
	{
		%val1 = "\c7[\c0Murder\c7] ";
	}
	if(%client.assaultCounts >= 1)
	{
		%val2 = "\c7[\c0Assault\c7] ";
	}
	if(%client.possessionCounts >= 1)
	{
		%val3 = "\c7[\c0Possession\c7] ";
	}
	if(%client.trespassingCounts >= 1)
	{
		%val4 = "\c7[\c0Trespassing\c7] ";
	}
	chatmessageall(%client,"" @ $wantedDeathMessage1 @ %client.name SPC $wantedDeathMessage2 @ %val1 @ %val2 @ %val3 @ %val4 @ "");
	if($Pref::Server::ResetOnDeath == 2)
    {
        %client.isWanted = 0;
        bottomprint(%client,"",0,0);
        %client.assaultCounts = 0;
        %client.murderCounts = 0;
		%client.possessionCounts = 0;
		%client.trespassingCounts = 0;
    } 
    else if($Pref::Server::ResetOnDeath == 1 && %client.assaultCounts == 0 && %client.murderCounts == 0)
    {
        %client.isWanted = 0;
		%client.possessionCounts = 0;
		%client.trespassingCounts = 0;
        bottomprint(%client,"",0,0);
	}
 
}
//Innocent Death
function innocentDeath(%client, %killerClient)
{
    if($Pref::Server::ResetOnDeath >= 1)
    {
        %client.isWanted = 0;
        bottomprint(%client,"",0,0);
		if(%killerClient.name $= "")
	{
		return;
	}
	if($Pref::Server::FreekillPunish == 1 && $Pref::Server::FreekillExplain == 1)
	{
		%killerClient.activeFreekill = 1;
		%killerClient.centerPrint("<font:arial:30>You have killed an innocent player! If you are not pardoned you will be killed.");
		%client.centerPrint("<font:arial:30>You have been freekilled! If the killer does not get pardoned you will be revived.");
		%killerClient.freekillSchedule = schedule(30000,0,freekillPunish, %killerClient, %client);
	} else {
		if($Pref::Server::FreekillPunish == 1)
		{
			%killerClient.activeFreekill = 1;
			%killerClient.centerPrint("<font:arial:30>You have killed an innocent player! They will be revived.");
			%client.centerPrint("<font:arial:30>You have been freekilled! You will now be revived.");
			%killerClient.freekillSchedule = schedule(3000,0,freekillPunish, %killerClient, %client);
		}
	}
        chatmessageall(%client,"<font:arial:28><color:666666>[<color:ffffff>Server<color:666666>] <color:6600cc><font:arial:25>"@ %client.name SPC "<color:ffffff>was freekilled by<color:6600cc>" SPC %killerClient.name @ "<color:ffffff>.");
	}
    else 
    {
		if(%killerClient.name $= "")
	{
		return;
	} else {
        chatmessageall(%client,"<font:arial:28><color:666666>[<color:ffffff>Server<color:666666>] <color:6600cc><font:arial:25>"@ %client.name SPC "<color:ffffff>was freekilled by<color:6600cc>" SPC %killerClient.name @ "<color:ffffff>.");
    }
	}
}
//Display wanted print
function GameConnection::wantedPrint(%client)
{
	if(%client.slyrTeam.name $= $Pref::Server::Team2 || $Pref::Server::WantedUseTeams == 0)
	{
	if($Pref::Server::ResetOnDeath == 0)
	{
  bottomprint(%client,$wantedBottomPrint, -1, 1);
	} else {
	if($Pref::Server::ResetOndeath == 1 && %client.assaultCounts >= 1 || $Pref::Server::ResetOndeath == 1 && %client.murderCounts >= 1)
	{
	bottomprint(%client,$wantedBottomPrint, -1, 1);
	} else {
	%client.isWanted = 0;
	%client.assaultCounts = 0;
	%client.murderCounts = 0;
	%client.trespassingCounts = 0;
	%client.possessionCounts = 0;
	}
	}
	}
}
//Packaged Functions
package WantedPackage
{   
	function ServerCmdDropTool(%client, %position)
	{
		if($Pref::Server::PreventItemPlant $= 1 && %client.slyrTeam.name $= $Pref::Server::Team1 || $Pref::Server::PreventItemPlant $= 1 && $Pref::Server::WantedUseTeams $= 0)
		{
			%player = %client.Player;
			%player.tool[%position] = 0;
			%item = %player.tool[%position];
			%client.chatMessage("Item discarded.");
			messageClient (%client, 'MsgItemPickup', '', %position, 0);
			%player.unmountImage (%item.image.mountPoint);
		} else {
			parent::serverCmdDropTool(%client, %position);
		}
	}
		
    function GameConnection::SpawnPlayer(%client)
    {
        Parent::SpawnPlayer(%client);
        if(%client.isWanted == 1)
        {
            %client.scheduleHUD = %client.schedule(1000, wantedPrint);
        }
		if(%client.isWanted == 0)
		{
			%client.assaultCounts = 0;
			%client.murderCounts = 0;
			%client.possessionCounts = 0;
			%client.trespassingCounts = 0;
		}
    }
    //Called when we take damage
    function Armor::Damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
    {
        parent::Damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
        //Wanted for assault if you are a prisoner that damaged a guard - you cannot assault yourself
        if(%sourceObject.client.slyrTeam.name $= $Pref::Server::Team2 && %obj.client.slyrTeam.name $= $Pref::Server::Team1 && %sourceObject.client !$= %obj.client || $Pref::Server::WantedUseTeams == 0 && %sourceObject.client !$= %obj.client)
        {
            %sourceObject.client.isWanted = 1;
            %sourceObject.client.assaultCounts++;
            bottomprint(%sourceObject.client, $wantedBottomPrint, -1, 1);
        }
    }
    //When someone dies
     function GameConnection::onDeath(%client, %killerPlayer, %killerClient, %type, %area)
    {
        parent::onDeath(%client, %killerPlayer, %killerClient, %type, %area);
        if(%client.wasRevived == 1)
		{
			%client.setLives(0);
			%client.wasRevived = 0;
		}
        if(%client.isWanted == 1 && %client.slyrTeam.name $= $Pref::Server::Team2 && %client !$= %killerClient || %client.isWanted == 1 && $Pref::Server::WantedUseTeams == 0 && %client !$= %killerClient)    
        {
            wantedDeath(%client);
       
        } 
        else if(%client.isWanted == 0 && %client.slyrTeam.name $= $Pref::Server::Team2 && %client !$= %killerClient || %client.isWanted == 0 && $Pref::Server::WantedUseTeams == 0 && %client !$= %killerClient)
        {
            innocentDeath(%client, %killerClient);
        }
        //Become wanted if a prisoner kills a guard
        if(%KillerClient.slyrTeam.name $= $Pref::Server::Team2 && %client.slyrTeam.name $= $Pref::Server::Team1 || $Pref::Server::WantedUseTeams == 0 && %KillerClient !$= %client)
        {
            %killerClient.isWanted = 1;
            %killerClient.murderCounts++;
			%killerClient.assaultCounts++;
            bottomprint(%killerClient, $wantedBottomPrint, -1, 1);
            
        }
        //If an inmate died they are no longer wanted if the pref is true
        if(%client.slyrTeam.name $= $Pref::Server::Team2 && $Pref::Server::ResetOnDeath == 2 || $Pref::Server::WantedUseTeams == 0 && $Pref::Server::ResetOnDeath == 2)
        {
           %client.isWanted = 0; 
        }
    }
    //Picking up items
		function armor::onCollision(%data,%this,%col,%vec,%vel)
		{
			%class = %col.getClassname();
			if(%class $= "Item")
			{
			if($Pref::Server::ItemsIllegal == 1)
		{
        if(%this.client.slyrTeam.name $= $Pref::Server::Team2 || $Pref::Server::WantedUseTeams == 0)
        {
            //Check the uiname of the item we are picking up
            if(%col.getDatablock().uiname !$= "")
            {
                %uiname = %col.getDatablock().uiName;
            }
            else
            {
                %uiname = %col.uiName;
            }
            //The push broom and fists do not count as concealed weapons
            %itemlist = getLegalItem();
            
            if(%uiname $= $LegalItem[1] || %uiname $= $LegalItem[2] || %uiname $= $LegalItem[3] || %uiname $= $LegalItem[4] || %uiname $= $LegalItem[5] || %uiname $= $LegalItem[6] || %uiname $= $LegalItem[7] || %uiname $= $LegalItem[8])
            {
				parent::onCollision(%data,%this,%col,%vec,%vel);
                return;
            }
            else
            {
				parent::onCollision(%data,%this,%col,%vec,%vel);
				%this.client.possessionCounts++;
                %this.client.isWanted = 1;
                bottomprint(%this.client, $wantedBottomPrint, -1, 1);
            }
        }
		}
		}
		parent::onCollision(%data,%this,%col,%vec,%vel);
    }
			
};
ActivatePackage(WantedPackage);

function getLegalItem(%client)
{
        %legalItems = $Pref::Server::LegalItems;
        %legalItemCount = 0;
        while(%legalItemCount < $Pref::Server::LegalItemCount)
        {
                %legalItemCount++;
                %legalItems = nextToken(%legalItems,"legalItem",",");
                $LegalItem[%legalItemCount] = %legalItem;
        }
}
function serverCmdKill(%client, %victim)
{
	%victim = findclientbyname(%victim);
		if(isObject(%victim))
		{
	if(%client.isAdmin == 1 || %client.isModerator == 1)
	{
		if(isObject(%victim.player))
		{
		%victim.player.kill();
		chatMessageAll(%client, "<color:ffff00>"@ %victim.name SPC "<color:ffffff>was killed by<color:ffff00>" SPC %client.name @"<color:ffffff>.");
		} else {
			%client.chatMessage("<color:ffffff>Target is already dead, silly silly.");
		}
	} else {
		%client.chatMessage("<color:ffffff>You're not admin, silly silly.");
	}
	} else {
		%client.chatMessage("<color:ffffff>Target does not exist, silly silly.");
	}
}
function serverCmdRes(%client, %victim)
{
	%victim = findclientbyname(%victim);
		if(isObject(%victim))
		{
	if(%client.isAdmin == 1 || %client.isModerator == 1)
	{
		if(!isObject(%victim.player))
		{
		%victim.instantRespawn();
		%victim.setLives(1);
		%victim.wasRevived = 1;
		%victim.slyr_deaths = (%victim.slyr_deaths - 1);
		%victim.dead = 0;
		chatMessageAll(%client, "<color:ffff00>"@ %victim.name SPC "<color:ffffff>was revived by<color:ffff00>" SPC %client.name @"<color:ffffff>.");
		} else {
			%client.chatMessage("<color:ffffff>Target is still alive, silly silly.");
		}
	} else {
		%client.chatMessage("<color:ffffff>You're not admin, silly silly.");
	}
		} else {
			%client.chatMessage("<color:ffffff>Target does not exist, silly silly.");
		}
}		
function serverCmdResBring(%client, %victim)
{
	%victim = findclientbyname(%victim);
		if(isObject(%victim))
		{
	if(%client.isAdmin == 1 || %client.isModerator == 1)
	{
		if(!isObject(%victim.player))
		{
		%victim.instantRespawn();
		%victim.setLives(1);
		%victim.wasRevived = 1;
		%victim.slyr_deaths = (%victim.slyr_deaths - 1);
		%victim.dead = 0;
		if(%client.getControlObject().getClassName() $= "Camera")
		{
			%victim.player.setTransform(%client.camera.getTransform());
		} else {
			%victim.player.setTransform(%client.player.getTransform());
		}
		chatMessageAll(%client, "<color:ffff00>"@ %victim.name SPC "<color:ffffff>was revived and fetched by<color:ffff00>" SPC %client.name @"<color:ffffff>.");
		} else {
			%client.chatMessage("<color:ffffff>Target is still alive, silly silly.");
		}
	} else {
		%client.chatMessage("<color:ffffff>You're not admin, silly silly.");
	}
		} else {
			%client.chatMessage("<color:ffffff>Target does not exist, silly silly.");
		}
}		
function freekillPunish(%client, %freekilledClient)
{
	if(!isObject(%freekilledClient.player))
	{
		%freekilledClient.instantRespawn();
		%freekilledClient.setLives(1);
		%freekilledClient.wasRevived = 1;
		%freekilledClient.slyr_deaths = (%victim.slyr_deaths - 1);
		%freekilledClient.dead = 0;
		chatMessageAll(%freekilledClient, "<color:ffff00>" @ %freekilledClient.name SPC "<color:ffffff>was revived after being freekilled.");
	}
	if(isObject(%client.player))
	{
		%client.player.kill();
		chatMessageAll(%freekilledClient, "<color:ffff00>" @ %client.name SPC "<color:ffffff>was killed as punishment for freekilling.");
	}
	%client.activeFreekill = 0;
}
function serverCmdPardon(%client, %target)
{
	if(%client.isAdmin)
	{
		%target = findclientbyname(%target);
		if(isObject(%target) && %target.activeFreekill == 1)
		{
			cancel(%target.freekillSchedule);
			%target.activeFreekill = 0;
			chatMessageAll(%client, "<color:ffff00>" @ %target.name @ "<color:ffffff>'s freekill was pardoned by <color:ffff00>" @ %client.name @ "<color:ffffff>.");
		} else {
			%client.chatMessage("<color:ffffff>Target either does not exist, or doesn't have an active freekill.");
		}
	} else {
		%client.chatMessage("<color:ffffff>Only admins can pardon freekills.");
	}
}
$wantedDeathMessage1 = "<font:arial:25><color:666666>[<color:ffffff>Server<color:666666>] <color:6600cc>";
$wantedDeathMessage2 = "<color:ffffff>was wanted for ";
$wantedBottomPrint = "<font:arial:30><color:ff0000>You are wanted <font:arial:20><color:ffffff>(If you're killed it won't be a freekill!)";
exec("./dropinventoryondeath.cs");